;
; ""
;
.include "tn2313def.inc"

.def	flags=R2
.equ	mode= 0
.equ	perekl= 1

.def	pressed_key=R3
.def	key=R4
.def	oldkey=R5
.def	rnd_l=R6
.def	rnd_h=R7
.def	rnd=R8
.def	sleep_counter_low=R9
.def	sleep_counter_high=R10
.def	scan=R11
.def	temp=R12
.def	perekl_mode_low=R13
.def	perekl_mode_high=R14
.def	score=R15
.def	roll=R17
.def	step=R18
.def	navatiy=R19
.def	zadervka_level_low=R20
.def	zadervka_level_high=R21

.def	zadervka_low=R24	;  SBIW
.def	zadervka_high=R25



.dseg
.org	SRAM_START
display:		.byte 3


.cseg
.org	0x0000

; .
	RJMP reset
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP timer_0
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
zadervka_level_0:	.dw	1250;   fisch
;	RJMP 0x00
	RJMP pin_changed
;	RJMP 0x00
;	RJMP 0x00
;	RJMP 0x00
;	RJMP 0x00
;	RJMP 0x00
;	RJMP 0x00
;	RJMP 0x00

;.

znak:			.db	0xFA,0x50,0xCE,0xDC,0x74,0xBC,0xBE,0x58,0xFE,0xFC,0x00,0x00
color:			.db	0xD0,0xE0,0xD0,0x70,0xB0,0xB0,0x70,0xE0




; .
reset:
	CLI

	CLR	R16
	OUT	EECR,R16
	OUT	MCUCR,R16

; WATCHDOG'a
	LDI	R17,0x18
	IN	R26,MCUSR
	CBR	R26,8
	OUT	MCUSR,R26
	OUT	WDTCR,R17
	OUT	WDTCR,R16

; .
	LDI	R26,SRAM_START
	LDI	R17,SRAM_SIZE
clear_ram:
	ST	X+,R16
	DEC	R17
	BRNE	clear_ram

; .
	LDI  R30,RAMEND
	OUT  SPL,R30

; .
	LDI	R30,0x80
	OUT	ACSR,R30
	OUT	CLKPR,R30
	CLR	R30
	OUT	CLKPR,R30
	OUT	PORTA,R30
	OUT	PORTD,R30
	OUT	TCCR0A,R30
	OUT	TCNT0,R30
	OUT	OCR0A,R30
	OUT	OCR0B,R30
	OUT	TCCR1A,R30
	OUT	TCCR1B,R30
	OUT	TCNT1H,R30
	OUT	TCNT1L,R30
	OUT	ICR1H,R30
	OUT	ICR1L,R30
	OUT	OCR1AH,R30
	OUT	OCR1AL,R30
	OUT	OCR1BH,R30
	OUT	OCR1BL,R30
	OUT	GIMSK,R30
	OUT	MCUCR,R30
	OUT	PCMSK,R30
	OUT	USICR,R30
	LDI	R30,0x02
	OUT	TIMSK,R30
	LDI	R30,0x03
	OUT	DDRA,R30
	OUT	TCCR0B,R30
	LDI	R30,0x0F
	OUT	DDRB,R30
	LDI	R30,0x7F
	OUT	DDRD,R30
	LDI	R30,0xF0
	OUT	PORTB,R30

; .
	IN	R30,PINB
	ANDI	R30,0xF0
	MOV	key,R30

; .
	LDI	R30,1
	MOV	score,R30
;  fish.
	LDI	R30,low(zadervka_level_0*2)
	LDI	R31,high(zadervka_level_0*2)
	LPM	zadervka_level_low,Z+
	LPM	zadervka_level_high,Z

	SEI


loop:
;  .
	RCALL	random

;     .
	TST	key
	BREQ	loop

;    .
	SBRS	flags,mode
	RJMP	start_fisch

.include "kubik.asm"
	RJMP	loop

start_fisch:

.include "fish.asm";

	RJMP	loop

;*************************************
;*******    0.01   *******
;*************************************
sotsec:
	ldi	r30,0x40
	ldi	r31,0xB2
del_1:
	adiw	r30,1
	brne	del_1

	dec	r16
	brne	sotsec
	RET

;*************************************
;**********     **********
;*************************************
.include "random.asm"

;*************************************
;***    timer0  ***
;*************************************
timer_0:

.include "timer0.asm"

	RETI

;**************************************
;***     ***
;**************************************
pin_changed:

	RETI
